#include <stdio.h>
FILE *fp;
// 1_inch 2.60*3.64 cm     524*734  (92*4+2*42)
// 2_inch 3.64*5.10 cm     734*1028 (45*3)
#define bw  524
#define bh  734
#define cw  734
#define ch 1028
unsigned char a[3072][3072][3];   // 10.1*15.2 cm
unsigned char b[bh][bw][3], b1[bw][bh][3];
unsigned char c[ch][cw][3], c1[cw][ch][3];
int k1[5]={42,658,1274,1890,2506};
int k2[4]={0,779,1558,2337};
int ww,hh,w0;
short h[27];
main(int ac,char **av)
{
  int i,j,k;
  if(ac<2){
    printf("\n\t****** compiling 1~2 inch photo *******\n");
    printf("\n\tUsage: ch12ph input.bmp [5; 1,3,5,7,9] [1, 0~9]\n");
    printf("\n\t\t\t\t jiang 2012,7\n");
    printf("\n\tinput.bmp:  heigh/width = ~1.4 portrait_style\n");
    printf("\n\t use image_tool_software cut & get your sample\n");
    printf("\n\t 2nd parameter:");
    printf("\n\t 9: 9 of 1_inch + 1 of 2_inch");
    printf("\n\t 7: 7 of 1_inch + 2 of 2_inch");
    printf("\n\t 5: 5 of 1_inch + 4 of 2_inch");
    printf("\n\t 3: 3 of 1_inch + 5 of 2_inch");
    printf("\n\t 1: 1 of 1_inch + 6 of 2_inch\n");
    printf("\n\t 3rd parameter: be background\n");
    printf("\n\t tell your dealer, want 6*4 inch photo. (2yuan/piece)\n\n");
    exit(0);
  }
  fp=fopen(av[1],"rb");
  if(fp==0){ printf("%s not found!\n",av[1]); exit(0); }
  fread(h,2,27,fp);  ww=h[9]; hh=h[11];  w0=((ww*3-1)/4+1)*4;
  if(h[0]!=19778){ printf("%s not a BMP file!\n",av[1]); exit(0); }
  if(ww>=3072 && hh >=3072){ printf("input pic is so large!\n"); exit(0); }
  printf("w: %d   h: %d\n",ww,hh);
  for(j=0;j<hh;j++)fread(&a[j][0][0],1,w0,fp);   fclose(fp);
  chtob(bh,bw,hh,ww);
  chtoc(ch,cw,hh,ww);
  if(ac>2){ sscanf(av[2],"%d",&w0);  w0/=2; w0*=2; w0++; } else w0=5;
  if(w0>9 || w0<1)w0=5;
  if(ac>3)  sscanf(av[3],"%d",&k); else k=1;
  if(k>0)fillb(k);
  printf("background: %d\n",k);
  for(j=0;j<2048;j++)for(i=0;i<3072;i++)for(k=0;k<3;k++)a[j][i][k]=255;
  if(w0==1 || w0==3){
    k=70;  for(i=0;i<w0;i++)pb(bh,bw,k1[i]+50,k);
           if(w0==1)pc1(cw,ch,k1[1]+100,k);
                    pc1(cw,ch,k1[3]+60,k);
    k=940; for(i=0;i<4;i++)pc(ch,cw,k2[i],k);
  }
  if(w0==5){
    k=70;  for(i=0;i<w0;i++)pb(bh,bw,k1[i],k);
    k=940; for(i=0;i<4;i++)pc(ch,cw,k2[i],k);
  }
  if(w0==7 || w0==9){
    k=50;  for(i=0;i<5;i++)pb(bh,bw,k1[i],k);
    k=940; pc(ch,cw,100,k); if(w0==7)pc(ch,cw,1100,k);
               pb1(bw,bh,2100,870); pb1(bw,bh,2100,1480);
    if(w0==9){ pb1(bw,bh,1100,870); pb1(bw,bh,1100,1480); }
  }
  h[9]=3072; h[11]=2048;
  printf("\n***output file name:  a.bmp\n\n");
  fp=fopen("a.bmp","wb"); fwrite(h,2,27,fp); fwrite(a,2048*3072,3,fp); exit(0);
}

fillb(int m)
{
  int i,j,k,kk,mm;
  mm=255-m;
  for(j=0;j<bh;j++)for(i=0;i<bw;i++){
    for(k=kk=0;k<3;k++)kk+=b[j][i][k];
    if(kk==765)for(k=0;k<3;k++)b[j][i][k]=mm;
  }
  for(j=0;j<bw;j++)for(i=0;i<bh;i++){
    for(k=kk=0;k<3;k++)kk+=b1[j][i][k];
    if(kk==765)for(k=0;k<3;k++)b1[j][i][k]=mm;
  }
  for(j=0;j<ch;j++)for(i=0;i<cw;i++){
    for(k=kk=0;k<3;k++)kk+=c[j][i][k];
    if(kk==765)for(k=0;k<3;k++)c[j][i][k]=mm;
  }
  for(j=0;j<cw;j++)for(i=0;i<ch;i++){
    for(k=kk=0;k<3;k++)kk+=c1[j][i][k];
    if(kk==765)for(k=0;k<3;k++)c1[j][i][k]=mm;
  }
}
chtob(h,w,hh,ww)
int h,w,hh,ww;
{
  float x; int i,j,k,l,m;
  x=ww; x/=w;
  printf("%f\n",x);
  for(j=0;j<h;j++)for(i=0;i<w;i++)for(k=0;k<3;k++)b[j][i][k]=255;
  for(j=0;j<h;j++)for(i=0;i<w;i++)for(k=0;k<3;k++){
    l=j*x;  m=i*x;
    if(l<hh)b[j][i][k]=a[l][m][k];
  }
  for(j=0;j<h;j++)for(i=0;i<w;i++)for(k=0;k<3;k++)b1[i][j][k]=b[j][i][k];
}
chtoc(h,w,hh,ww)
int h,w,hh,ww;
{
  float x; int i,j,k,l,m;
  x=ww; x/=w;
  printf("%f\n",x);
  for(j=0;j<h;j++)for(i=0;i<w;i++)for(k=0;k<3;k++)c[j][i][k]=255;
  for(j=0;j<h;j++)for(i=0;i<w;i++)for(k=0;k<3;k++){
    l=j*x;  m=i*x;
    if(l<hh)c[j][i][k]=a[l][m][k];
  }
  for(j=0;j<h;j++)for(i=0;i<w;i++)for(k=0;k<3;k++)c1[i][j][k]=c[j][i][k];
}
pb(h,w,x,y)
int h,w,x,y;
{
  int i,j,k;
  for(j=0;j<h;j++)for(i=0;i<w;i++)for(k=0;k<3;k++)a[j+y][i+x][k]=b[j][i][k];
}
pb1(h,w,x,y)
int h,w,x,y;
{
  int i,j,k;
  for(j=0;j<h;j++)for(i=0;i<w;i++)for(k=0;k<3;k++)a[j+y][i+x][k]=b1[j][i][k];
}
pc(h,w,x,y)
int h,w,x,y;
{
  int i,j,k;
  for(j=0;j<h;j++)for(i=0;i<w;i++)for(k=0;k<3;k++)a[j+y][i+x][k]=c[j][i][k];
}
pc1(h,w,x,y)
int h,w,x,y;
{
  int i,j,k;
  for(j=0;j<h;j++)for(i=0;i<w;i++)for(k=0;k<3;k++)a[j+y][i+x][k]=c1[j][i][k];
}

